'
' * Created by toText.net.
' * Date: 10/02/2009
' 

Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

''' <summary>
''' Form used for reception and display of delivery report data from toText.net.
''' </summary>
Public Class DeliveryReport
	Inherits Page
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	#Region "Data"
	Protected mobileNoReceived As TextBox
	Protected timestampReceived As TextBox
	Protected statusReceived As TextBox
	
	Private Const MOBILE_NO_API_STRING As String = "mobileNumber"
	Private Const TIMESTAMP_API_STRING As String  = "dateAndTime"
	Private Const STATUS_API_STRING As String  = "status"
	#End Region
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	#Region "Page Init & Exit (Open/Close DB connections here...)"

	Protected Sub PageInit(sender As Object, e As System.EventArgs)
	End Sub
	'----------------------------------------------------------------------
	Protected Sub PageExit(sender As Object, e As System.EventArgs)
	End Sub

	#End Region
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	#Region "Page Load"
	Private Sub Page_Load(sender As Object, e As System.EventArgs)
		'------------------------------------------------------------------
		If IsPostBack Then
		End If
		'------------------------------------------------------------------
		''Extract any data out from the request string sent by toText.net
		UpdateApplicationStorage(MOBILE_NO_API_STRING)
		UpdateApplicationStorage(TIMESTAMP_API_STRING)
		UpdateApplicationStorage(STATUS_API_STRING)
		
		''Populate the controls with the data.
		UpdateControlFromStorageData(mobileNoReceived, MOBILE_NO_API_STRING)
		UpdateControlFromStorageData(timestampReceived, TIMESTAMP_API_STRING)
		UpdateControlFromStorageData(statusReceived, STATUS_API_STRING)

	End Sub
	#End Region
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	#Region "Private Methods"
	''' <summary>
	''' Updates application data from data received from the toText.net API.
	''' </summary>
	''' <param name="apiString">The string identifying the parameter</param>
	private sub UpdateApplicationStorage(apiString as String)
		If Request(apiString) IsNot Nothing Then
			Application(apiString) = Request(apiString).ToString()
		Else
			Application(apiString) = Nothing
		End If
	End Sub
		
	''' <summary>
	''' Updates a textbox from storage data.
	''' </summary>
	''' <param name="textboxToUpdate">The textbox to populate</param>
	''' <param name="apiString">The string identifying the stored data</param>
	private sub UpdateControlFromStorageData(textboxToUpdate as TextBox, apiString as String)
		If Application(apiString) IsNot Nothing Then
			textboxToUpdate.Text = Application(apiString).ToString()
		Else
			textboxToUpdate.Text = String.Empty
		End If
	End Sub
	
	#End Region
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	#Region "Initialize Component"

	Protected Overloads Overrides Sub OnInit(e As EventArgs)
		InitializeComponent()
		MyBase.OnInit(e)
	End Sub
	'----------------------------------------------------------------------
	Private Sub InitializeComponent()
		'------------------------------------------------------------------
		AddHandler Me.Load, New System.EventHandler(AddressOf Page_Load)
		AddHandler Me.Init, New System.EventHandler(AddressOf PageInit)
		AddHandler Me.Unload, New System.EventHandler(AddressOf PageExit)
		'------------------------------------------------------------------
	End Sub
	#End Region
	'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
End Class
